<?php
/**
 * @file
 * Contains utility class.
 */

/**
 * @file
 * This class represents utility methods.
 */
require 'miniorange_ldap_support.php';
class MiniorangeLdapUtility {

  /**
   * Check if customer is registered.
   */
  public static function isCustomerRegistered() {
    $email = variable_get('miniorange_ldap_admin_email', NULL);
    $phone = variable_get('miniorange_ldap_admin_phone', NULL);
    $customer_key = variable_get('miniorange_ldap_admin_customer_key', NULL);
    if (!$email or !$phone or !$customer_key or !is_numeric(trim($customer_key))) {
      return 0;
    }
    else {
      return 1;
    }
  }
  /**
   * This function adds the support form on the tabs.
   */
  public static function AddSupportButton(array &$form, $form_state)
    {
      $form['markup_idp_attr_header_top_support'] = array('#markup' => '</div><div class="mo_saml_table_layout_support_1 mo_saml_container" id="ma_saml_support_query">',);

      $form['markup_support_1'] = array(
      '#markup' => '<h3><b>Feature Request/Contact Us:</b></h3><div><i>Need any help or do you wish to test any of our LDAP premium modules? We can here for you. Just send us a query and we will get back to you soon.<br /></i></div><br>',
      );

      $form['miniorange_saml_email_address'] = array(
      '#type' => 'textfield',
      '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your email'),
      '#default_value' => variable_get('miniorange_saml_customer_admin_email'),
      );

      $form['miniorange_saml_phone_number'] = array(
      '#type' => 'textfield',
      '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your phone number'),
      '#default_value' => variable_get('miniorange_saml_customer_admin_phone'),
      );

      $form['miniorange_saml_support_query'] = array(
      '#type' => 'textarea',
      '#cols' => '10',
      '#rows' => '5',
      '#attributes' => array('style' => 'width:100%','placeholder' => 'Write your query here'),
      );

      $form['miniorange_saml_support_submit_click'] = array(
      '#type' => 'submit',
      '#value' => t('Submit Query'),
      '#submit' => array('send_support_query'),
      );

      $form['miniorange_saml_support_note'] = array(
      '#markup' => '<div><br/>If you want custom features in the plugin, just drop an email to <a href="mailto:drupalsupport@xecurify.com">drupalsupport@xecurify.com</a></div></div>'
      );
    }
  /**
   * Encrypt.
   */
  public static function encrypt($str) {
    $key = variable_get('miniorange_ldap_customer_admin_token', NULL);
    $block = mcrypt_get_block_size('rijndael_128', 'ecb');
    $pad = $block - (strlen($str) % $block);
    $str .= str_repeat(chr($pad), $pad);
    return base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $str, MCRYPT_MODE_ECB));
  }

  /**
   * Decrypt.
   */
  public static function decrypt($value) {
    $key = variable_get('miniorange_ldap_customer_admin_token', NULL);
    $string = rtrim(
      mcrypt_decrypt(
        MCRYPT_RIJNDAEL_128,
        $key,
        base64_decode($value),
        MCRYPT_MODE_ECB,
        mcrypt_create_iv(
          mcrypt_get_iv_size(
            MCRYPT_RIJNDAEL_128,
            MCRYPT_MODE_ECB
          ),
          MCRYPT_RAND
        )
      ), "\0"
    );
    return trim($string, "\0..\32");
  }

  /**
   * Check if cURL is installed.
   */
  public static function isCurlInstalled() {
    if (in_array('curl', get_loaded_extensions())) {
      return 1;
    }
    else {
      return 0;
    }
  }

  /**
   * Check if an extension is installed.
   */
  public static function isExtensionInstalled($name) {
    if (in_array($name, get_loaded_extensions())) {
      return TRUE;
    }
    else {
      return FALSE;
    }
  }

}
