<?php

drupal_add_css( drupal_get_path('module', 'ldap_auth'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

include_once 'ldap_auth.module';
include_once 'includes/Utilities.php';
function ldap_auth_ldap_config($form, $form_state)
{
    $status='';

    $status=variable_get('miniorange_ldap_config_status','two');

    $form['#prefix'] = '<div style="background-color: rgb(241,241,241) ; padding: 20px">';
    $form['#suffix'] = '</div>';

    if($status=='review_config')
    {
        MiniorangeLdapUtility::AddSupportButton($form, $form_state);
       $form['miniorange_ldap_enable_ldap_markup'] = array(
        '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
        '#suffix' => "</div>",
        '#markup' => "<div><h1><b>Login With LDAP</b></h1><br></div>",
        );
       $form['miniorange_ldap_enable_ldap'] = array(
            '#type' => 'checkbox',
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
            '#suffix' => "</div>",
            '#title' => t('Enable Login with LDAP '),
            '#default_value' => variable_get('miniorange_ldap_enable_ldap', ''),
        );
        $form['set_of_radiobuttons']['miniorange_ldap_authentication'] = array(
            '#type' => 'radios',
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
            '#suffix' => "</div>",
            '#disabled' => 'true',
            '#title' => t('Authentication restrictions: [Premium] '),
            '#description' => t('Only particular personalities will be able to login by selecting the above option.'),
            '#tree' => TRUE,
            '#default_value' => is_null(variable_get('miniorange_ldap_authentication'))?2:variable_get('miniorange_ldap_authentication'),
            '#options' => array(0 => t('Drupal and LDAP Users'), 1 => t('Administrators of Drupal'), 2 => t('LDAP Users')),
          );

    $form['miniorange_ldap_enable_auto_reg'] = array(
        '#type' => 'checkbox',
        '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
        '#suffix' => "</div>",
        '#title' => t('Enable Auto Registering users if they do not exist in Drupal '),
        '#default_value' => variable_get('miniorange_ldap_enable_auto_reg', '0'),
        );

    $form['ldap_server'] = array(
        '#markup' => "<br><br><div style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%' id='enable_ldap'>
            <p>You need to find out the values of the below given field from your LDAP administrator</p>
            <h1><b><br><br>LDAP Connection Information</b></h1>
            </div>",
        );
    $form['miniorange_ldap_server'] = array(
	        '#type' => 'textfield',
	        '#title' => t('LDAP Server'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
            '#suffix' => "</div>",
            '#id' => 'mo_ldap_server',
	        '#default_value' => variable_get('miniorange_ldap_server', ''),
	        '#description' => "Specify the host name for the LDAP server eg: ldap://myldapserver.domain:389 , ldap://89.38.192.1:389. When using SSL, the host may have to take the form ldaps://host:636",
            '#attributes' => array('placeholder' => 'ldap://<server-address or IP>:<port>'),
        );
    $form['miniorange_ldap_enable_tls'] = array(
        '#type' => 'checkbox',
        '#prefix' => "<div style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
        '#suffix' => "</div>",
        '#id' => 'check',
        '#disabled' => true,
        '#title' => t('Enable TLS (Check this only if your server use TLS Connection)<b>[Premium Feature]</b>'),
        '#default_value' => variable_get('miniorange_ldap_enable_tls', ''),
    );
    $form['miniorange_ldap_contact_server_button'] = array(
        '#type' => 'submit',
        '#prefix' => "<div style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
        '#suffix' => "</div><br>",
        '#value' => t('Contact LDAP Server'),
        '#submit' => array('test_ldap_conn'),
    );
    $form['miniorange_ldap_server_account_username'] = array(
	        '#type' => 'textfield',
	        '#title' => t('Service Account Username:'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
            '#suffix' => "</div>",
            '#id' => 'test_username',
	        '#default_value' => variable_get('miniorange_ldap_server_account_username', ''),
	        '#description' => "This service account username will be used to establish the connection. Specify the Service Account Username of the LDAP server in the either way as follows Username@domainname or domainname\Username. or Distinguished Name(DN) format",
            '#attributes' => array('placeholder' => 'CN=service,DC=domain,DC=com'),
    );

    $form['miniorange_ldap_server_account_password'] = array(
	        '#type' => 'password',
	        '#title' => t('Service Account Password:'),
            '#id' => 'test_password',
            '#prefix' => "<div style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
            '#suffix' => "</div>",
	        '#default_value' => variable_get('miniorange_ldap_server_account_password', ''),
            '#attributes' => array('placeholder' => 'Enter password for Service Account'),
        );
    $form['miniorange_ldap_test_connection_button'] = array(
        '#type' => 'submit',
        '#prefix' => "<div style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
        '#suffix' => "</div><br>",
        '#value' => t('Test Connection'),
        '#submit' => array('test_connection_ldap'),
        '#attributes' => array('class'=>array('my-form-class')),
    );

    $form['miniorange_ldap_search_base'] = array(
	        '#type' => 'textfield',
	        '#title' => t('Search Base(s):'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
            '#suffix' => "</div>",
            '#id' => 'firstname',
            '#description' => 'This is the LDAP Tree under which we will search for the users for authentication. If we are not able to find a user in LDAP it means they are not present in this search base or any of its sub trees. They may be present in some other .
                Provide the distinguished name of the Search Base object. <b>eg. cn=Users,dc=domain,dc=com.
                Multiple Search Bases</b> are supported in the Premium version of the plugin.',
	        '#default_value' => variable_get('miniorange_ldap_search_base', ''),
            '#attributes' => array('placeholder' => 'DC=domain, DC=com'),
    );
    $form['miniorange_ldap_username_attribute'] = array(
	        '#type' => 'textfield',
	        '#title' => t('Username Attribute:'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%'>",
            '#suffix' => "</div>",
            '#id' => 'firstname',
            '#description' => 'This field is important for two reasons.
            1. While searching for users, this is the attribute that is going to be matched to see if the user exists.
            2. If you want your users to login with their username or firstname.lastname or email - you need to specify those options in this field. e.g. <b>LDAP_ATTRIBUTE</b>. Replace <b><LDAP_ATTRIBUTE></b> with the attribute where your username is stored. Some common attributes are</p>
            <table>
                <tr>
                    <td>common name</td>
                    <td>cn</td>
                    <td></td>
                    <td></td>
                </tr>
                <tr>
                    <td>email</td>
                    <td>mail</td>
                    <td></td>
                    <td></td>
                </tr>
                <tr>
                    <td>logon name</td>
                    <td>samaccountName</td>
                    <td>or</td>
                    <td>userPrincipalName</td>
                </tr>
            </table>
            <p>You can even allow logging in with multiple attributes, separated with  <b>semicolon</b> . e.g. you can allow logging in with username or email. <strong>e.g. cn;mail</strong></p>',
	        '#default_value' => variable_get('miniorange_ldap_username_attribute', ''),
            '#attributes' => array('placeholder' => 'eg. mail'),
    );
    $form['save_user_mapping'] = array(
        '#markup' => "
            <div style='background-color: white; padding: 6px ;margin-left: 0px; width: 65%' id='enable_ldap'>
                <p>Please make clear that the attributes that we are showing are examples and the actual ones could be different. These should be confirmed with the LDAP Admin.<p>
            <br>",
    );

    $form['back_step_3'] = array(
    '#type' => 'submit',
    '#value' => t('Reset Configurations'),
    '#submit' => array('miniorange_ldap_back_2'),
    '#attributes' => array('class'=>array('my-form-class')),
    );

     $form['save_config_edit'] = array(
        '#type' => 'submit',
        '#value' => t('Save Changes'),
        '#submit' => array('miniorange_ldap_review_changes'),
    );
    $form['miniorange-ldap_div_close']= array(
        '#markup' => "",
    );
    //MiniorangeLdapUtility::AddSupportButton($form, $form_state);

    }

  if($status=='one')
  {

    $form['miniorange_ldap_enable_ldap_markup'] = array(
        '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
        '#suffix' => "</div>",
        '#markup' => "<div><h1><b>Login With LDAP</b></h1><br></div>",
    );
        MiniorangeLdapUtility::AddSupportButton($form, $form_state);
    $form['miniorange_ldap_enable_ldap'] = array(
        '#type' => 'checkbox',
        '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
        '#suffix' => "</div>",
        '#description' => 'Enabling LDAP login will protect your login page by your configured LDAP. Please check this only after you have successfully tested your configuration as the default WordPress login will stop working',
        '#title' => t('Enable Login with LDAP '),
        '#default_value' => variable_get('miniorange_ldap_enable_ldap', ''),
    );
    $form['set_of_radiobuttons']['miniorange_ldap_authentication'] = array(
        '#type' => 'radios',
        '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
        '#suffix' => "</div>",
        '#disabled' => 'true',
        '#title' => t('Authentication restrictions: [Premium] '),
        '#description' => t('Only particular personalities will be able to login by selecting the above option.'),
        '#tree' => TRUE,
        '#default_value' => is_null(variable_get('miniorange_ldap_authentication'))?2:variable_get('miniorange_ldap_authentication'),
        '#options' => array(0 => t('Drupal and LDAP Users'), 1 => t('Administrators of Drupal'), 2 => t('LDAP Users')),
      );
    $form['miniorange_ldap_enable_auto_reg'] = array(
        '#type' => 'checkbox',
        '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
        '#suffix' => "</div>",
        '#title' => t('Enable Auto Registering users if they do not exist in Drupal'),
        '#default_value' => variable_get('miniorange_ldap_enable_auto_reg', '0'),
    );
    $form['back_step_55'] = array(
        '#type' => 'submit',
        '#id' => 'button_config',
        '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
        '#suffix' => "</div>",
        '#value' => t('BACK'),
        '#submit' => array('miniorange_ldap_back_5'),
        '#attributes' => array('class'=>array('my-form-class')),
    );
    $form['next_step_1'] = array(
        '#type' => 'submit',
        '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
        '#suffix' => "</div>",
        '#id' => 'button_config',
        '#value' => t('Save & Review Configurations'),
        '#submit' => array('miniorange_ldap_next_1'),
        '#attributes' => array('class'=>array('my-form-class')),
    );
    }

    else if($status=='two')
    {
        MiniorangeLdapUtility::AddSupportButton($form, $form_state);
        $form['mo_ldap_local_configuration_form_action'] = array(
            '#markup' => "<input type='hidden' name='option' id='mo_ldap_local_configuration_form_action' value='mo_ldap_local_save_config'></input>",
        );
        $form['ldap_server'] = array(
        '#markup' => "
            <div style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%' id='enable_ldap'>
            <strong>Note: </strong>You need to find out the values of the below given field from your LDAP administrator</strong><br><br>
            <h1><b>LDAP Connection Information</b></h1><br>
            </div>",
        );
        $form['miniorange_ldap_server'] = array(
	        '#type' => 'textfield',
	        '#title' => t('LDAP Server'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "",
            '#id' => 'mo_ldap_server',
	        '#default_value' => variable_get('miniorange_ldap_server', ''),
	        '#description' => "Specify the host name for the LDAP server eg: ldap://myldapserver.domain:389 , ldap://89.38.192.1:389. When using SSL, the host may have to take the form ldaps://host:636",
            '#attributes' => array('placeholder' => 'ldap://<server-address or IP>:<port>'),
        );
        $form['miniorange_ldap_contact_server_button'] = array(
            '#type' => 'submit',
            '#prefix' => "<div style='color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div><br>",
            '#value' => t('Contact LDAP Server'),
            '#submit' => array('test_ldap_conn'),
        );
        $form['miniorange_ldap_enable_tls'] = array(
        '#type' => 'checkbox',
        '#prefix' => "<div style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
        '#suffix' => "</div>",
        '#id' => 'check',
        '#disabled' => true,
        '#title' => t('Enable TLS (Check this only if your server use TLS Connection)<b>[Premium Feature]</b>'),
        '#default_value' => variable_get('miniorange_ldap_enable_tls', ''),
        );
        $form['miniorange_ldap_server_account_username'] = array(
	        '#type' => 'textfield',
	        '#title' => t('Service Account Username:'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
            '#id' => 'firstname',
	        '#default_value' => variable_get('miniorange_ldap_server_account_username', ''),
	        '#description' => "This service account username will be used to establish the connection. Specify the Service Account Username of the LDAP server in the either way as follows Username@domainname or domainname\Username. or Distinguished Name(DN) format",
            '#attributes' => array('placeholder' => 'CN=service,DC=domain,DC=com'),
        );

        $form['miniorange_ldap_server_account_password'] = array(
	        '#type' => 'password',
	        '#title' => t('Service Account Password:'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
            '#id' => 'firstname',
	        '#default_value' => variable_get('miniorange_ldap_server_account_password', ''),
            '#attributes' => array('placeholder' => 'Enter password for Service Account'),
        );
        $form['miniorange_ldap_test_connection_button'] = array(
            '#type' => 'submit',
            '#prefix' => "<div style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
            '#value' => t('Test Connection'),
            '#submit' => array('test_connection_ldap'),
            '#attributes' => array('class'=>array('my-form-class')),
        );
        $form['next_step_2'] = array(
            '#type' => 'submit',
            '#id' => 'button_config',
            '#value' => t('NEXT'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
            '#submit' => array('miniorange_ldap_next_2'),
            '#attributes' => array(),
        );
}

else if($status=='three')
{
    MiniorangeLdapUtility::AddSupportButton($form, $form_state);
    $form['miniorange_ldap_search_base'] = array(
    '#type' => 'textfield',
    '#title' => t('Search Base(s):'),
    '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
    '#suffix' => "</div>",
    '#id' => 'firstname',
    '#description' => 'This is the LDAP Tree under which we will search for the users for authentication. If we are not able to find a user in LDAP it means they are not present in this search base or any of its sub trees. They may be present in some other .
        Provide the distinguished name of the Search Base object. <b>eg. cn=Users,dc=domain,dc=com.
        Multiple Search Bases are supported in the Premium version of the plugin.</b>',
    '#default_value' => variable_get('miniorange_ldap_search_base', ''),
    '#attributes' => array('placeholder' => 'DC=domain, DC=com'),
        );
    $form['miniorange_ldap_username_attribute'] = array(
	    '#type' => 'textfield',
	    '#title' => t('Username Attribute:'),
        '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
        '#suffix' => "</div>",
        '#id' => 'firstname',
        '#description' => 'This field is important for two reasons.
            1. While searching for users, this is the attribute that is going to be matched to see if the user exists.
            2. If you want your users to login with their username or firstname.lastname or email - you need to specify those options in this field. e.g. <b>LDAP_ATTRIBUTE</b>. Replace <b><LDAP_ATTRIBUTE></b> with the attribute where your username is stored. Some common attributes are</p>
            <table>
                <tr>
                    <td>common name</td>
                    <td>cn</td>
                    <td></td>
                    <td></td>
                </tr>
                <tr>
                    <td>email</td>
                    <td>mail</td>
                    <td></td>
                    <td></td>
                </tr>
                <tr>
                    <td>logon name</td>
                    <td>samaccountName</td>
                    <td>or</td>
                    <td>userPrincipalName</td>
                </tr>
            </table>
            <p>You can even allow logging in with multiple attributes, separated with  <b>semicolon</b> . e.g. you can allow logging in with username or email. <strong>e.g. cn;mail</strong></p>',
        '#default_value' => variable_get('miniorange_ldap_username_attribute', ''),
        '#attributes' => array('placeholder' => 'eg. mail'),
    );
       $form['back_step_3'] = array(
        '#type' => 'submit',
        '#id' => 'button_config',
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
    '#value' => t('BACK'),
    '#submit' => array('miniorange_ldap_back_3'),
    '#attributes' => array('class'=>array('my-form-class')),
    );
    $form['next_step1'] = array(
            '#type' => 'submit',
            '#id' => 'button_config',
            '#value' => t('NEXT'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
            '#submit' => array('miniorange_ldap_next_to_1'),
            '#attributes' => array(),
    );

    }
    else if($status=='four')
    {
        MiniorangeLdapUtility::AddSupportButton($form, $form_state);
        $form['test_username'] = array(
        '#markup' => "
            <div style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%' id='enable_ldap'>
                <h1><b>Test Authentication</b></h1><br>
                <p><i>Drupal username is mapped to the LDAP attribute defined in the Search Filter attribute in LDAP. Ensure that you have an administrator user in LDAP with the same attribute value.</i></p>
            </div>",
    );

    $form['miniorange_ldap_test_username'] = array(
	        '#type' => 'textfield',
	        '#title' => t('Username:'),
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
            '#id' => 'firstname',
	        '#default_value' => variable_get('miniorange_ldap_test_username', ''),
            '#attributes' => array('placeholder' => 'Enter username for Service Account'),
        );
    $form['miniorange_ldap_test_password'] = array(
	        '#type' => 'password',
	        '#title' => t('Password:'),
            '#prefix' => "<div style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
            '#id' => 'firstname',
	        '#default_value' => variable_get('miniorange_ldap_test_password', ''),
            '#attributes' => array('placeholder' => 'Enter password for Service Account'),

        );
    $form['back_step_3'] = array(
        '#type' => 'submit',
        '#id' => 'button_config',
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
    '#value' => t('BACK'),
    '#submit' => array('miniorange_ldap_back_5'),
    '#attributes' => array('class'=>array('my-form-class')),
    );
    $form['next_review_changes'] = array(
        '#type' => 'submit',
        '#id' => 'button_config',
            '#prefix' => "<div  style='background-color: white; padding: 6px ;margin-left: 10px; width: 65%'>",
            '#suffix' => "</div>",
    '#value' => t('Review/Edit Configurations'),
    '#submit' => array('miniorange_ldap_save_changes'),
    '#attributes' => array('class'=>array('my-form-class')),
    );
   }
    return $form;
}
function miniorange_ldap_next_1($form, $form_state)
{
    variable_set('miniorange_ldap_config_status', 'review_config');
    if(!empty($form['miniorange_ldap_enable_ldap']['#value'])){
        $enable_ldap = $form['miniorange_ldap_enable_ldap']['#value'];
        variable_set('miniorange_ldap_enable_ldap',$enable_ldap);
    }
    if(!empty($form['miniorange_ldap_enable_auto_reg']['#value'])){
        $auto_reg_users = $form['miniorange_ldap_enable_auto_reg']['#value'];
        variable_set('miniorange_ldap_enable_auto_reg',$auto_reg_users);
    }
    user_cookie_save(array("mo_ldap_test" => true));
    $error = test_mo_config();
    if($error[0] == 'error')
        drupal_set_message(t($error[1]),'error');
    else
        drupal_set_message(t($error[1]));
}
function test_connection_ldap()
{
    $server_account_username ="";
    $server_account_password ="";
    if(empty(trim($_POST['miniorange_ldap_server_account_username'])) || empty(trim($_POST['miniorange_ldap_server_account_password'])) )
    {
        drupal_set_message(t("Username or Password can not be empty"),'error'); return;
    }
    if(isset($_POST['miniorange_ldap_server_account_username']) && !empty($_POST['miniorange_ldap_server_account_username']))
    {
        $server_account_username = check_plain($_POST['miniorange_ldap_server_account_username']);
        variable_set('miniorange_ldap_server_account_username', $server_account_username);
    }
    if(isset($_POST['miniorange_ldap_server_account_password']) && !empty($_POST['miniorange_ldap_server_account_password']))
    {
        $server_account_password = check_plain($_POST['miniorange_ldap_server_account_password']);
        variable_set('miniorange_ldap_server_account_password', $server_account_password);
    }
    $error = array();
    user_cookie_save(array("mo_ldap_test" => true));
    $error = test_mo_config();
    if($error[0] == 'error')
        drupal_set_message(t($error[1]),'error');
    else
        drupal_set_message(t($error[1]));
}
function miniorange_ldap_back_1($form,$form_state)
{
    variable_set('miniorange_ldap_config_status', 'one');
}
function miniorange_ldap_back_2($form,$form_state)
{
    variable_del('miniorange_ldap_enable_ldap');
    // variable_del('miniorange_ldap_authenticate_admin');
    // variable_del('miniorange_ldap_authenticate_drupal_users');
    variable_del('miniorange_ldap_enable_auto_reg');
    variable_del('miniorange_ldap_server');
    variable_del('miniorange_ldap_enable_tls');
    variable_del('miniorange_ldap_server_account_username');
    variable_del('miniorange_ldap_server_account_password');
    variable_del('miniorange_ldap_search_base');
    variable_del('miniorange_ldap_username_attribute');
    variable_del('miniorange_ldap_test_username');
    variable_del('miniorange_ldap_test_password');

    variable_set('miniorange_ldap_config_status', 'two');
}

function miniorange_ldap_back_3($form,$form_state)
{
    variable_set('miniorange_ldap_config_status', 'two');
}
function miniorange_ldap_back_5($form,$form_state)
{
    variable_set('miniorange_ldap_config_status', 'three');
}
function miniorange_ldap_back_4($form,$form_state)
{
    variable_set('miniorange_ldap_config_status', 'four');
}

function miniorange_ldap_next_to_1($form, $form_state)
{
    variable_set('miniorange_ldap_config_status', 'one');

    if(!empty($form['miniorange_ldap_search_base']['#value']))
    {
        $searchBase = $form['miniorange_ldap_search_base']['#value'];
        variable_set('miniorange_ldap_search_base',$searchBase);
    }
    if(!empty($form['miniorange_ldap_username_attribute']['#value']))
    {
        $usernameAttribute = $form['miniorange_ldap_username_attribute']['#value'];
        variable_set('miniorange_ldap_username_attribute',$usernameAttribute);
    }
}

/**
 * Send support query
 */
function send_support_query(&$form, $form_state)
{
    $email ="";
    $phone = "";
    $query="";
if(isset($form['miniorange_saml_email_address']['#value']) && !empty($form['miniorange_saml_email_address']['#value']))
  $email = $form['miniorange_saml_email_address']['#value'];
if(isset($form['miniorange_saml_email_address']['#value']) && !empty($form['miniorange_saml_email_address']['#value']))
  $phone = $form['miniorange_saml_phone_number']['#value'];
if(isset($form['miniorange_saml_email_address']['#value']) && !empty($form['miniorange_saml_email_address']['#value']))
  $query = $form['miniorange_saml_support_query']['#value'];
  if(empty($email)||empty($query)){
  drupal_set_message(t('The <b><u>Email</u></b> and <b><u>Query</u></b> fields are mandatory.'), 'error');
  return;
  } elseif(!valid_email_address($email)) {
  drupal_set_message(t('The email address <b><i>' . $email . '</i></b> is not valid.'), 'error');
  return;
  }
  $support = new MiniOrangeLDAPSupport($email, $phone, $query);
  $support_response = $support->sendSupportQuery();
  if($support_response) {
  drupal_set_message(t('Support query successfully sent'));
  }
  else {
  drupal_set_message(t('Error sending support query'), 'error');
  }
}

function miniorange_ldap_next_2($form, $form_state)
{
    variable_set('miniorange_ldap_config_status', 'three');

    if(!empty(trim($form['miniorange_ldap_server']['#value'])))
    {
        $mo_ldap_server = $form['miniorange_ldap_server']['#value'];
        variable_set('miniorange_ldap_server', $mo_ldap_server);
    }
    if(!empty($form['miniorange_ldap_enable_tls']['#value']))
    {
        $enable_tls = $form['miniorange_ldap_enable_tls']['#value'];
        variable_set('miniorange_ldap_enable_tls', $enable_tls);
    }
    if(!empty($form['miniorange_ldap_server_account_username']['#value']))
    {
        $server_account_username = $form['miniorange_ldap_server_account_username']['#value'];
        variable_set('miniorange_ldap_server_account_username', $server_account_username);
    }
    if(!empty($form['miniorange_ldap_server_account_password']['#value']))
    {
        $server_account_password = $form['miniorange_ldap_server_account_password']['#value'];
        variable_set('miniorange_ldap_server_account_password', $server_account_password);
    }
}


function miniorange_ldap_next_3($form, $form_state)
{
    variable_set('miniorange_ldap_config_status', 'four');

    if(!empty($form['miniorange_ldap_search_base']['#value']))
    {
        $searchBase = $form['miniorange_ldap_search_base']['#value'];
        variable_set('miniorange_ldap_search_base',$searchBase);
    }
    if(!empty($form['miniorange_ldap_username_attribute']['#value']))
    {
        $usernameAttribute = $form['miniorange_ldap_username_attribute']['#value'];
        variable_set('miniorange_ldap_username_attribute',$usernameAttribute);
    }
}

function miniorange_ldap_save_changes($form, $form_state)
{
    variable_set('miniorange_ldap_config_status', 'review_config');

    if(!empty($form['miniorange_ldap_search_base']['#value']))
    {
        $searchBase = $form['miniorange_ldap_search_base']['#value'];
        variable_set('miniorange_ldap_search_base',$searchBase);
    }
    if(!empty($form['miniorange_ldap_username_attribute']['#value']))
    {
        $usernameAttribute = $form['miniorange_ldap_username_attribute']['#value'];
        variable_set('miniorange_ldap_username_attribute',$usernameAttribute);
    }
    if(!empty($form['miniorange_ldap_test_username']['#value']))
    {
        $testUsername = $form['miniorange_ldap_test_username']['#value'];
        variable_set('miniorange_ldap_test_username',$testUsername);
    }
    if(!empty($form['miniorange_ldap_test_password']['#value']))
    {
        $testPassword = $form['miniorange_ldap_test_password']['#value'];
        variable_set('miniorange_ldap_test_password',$testPassword);
    }

}

function miniorange_ldap_review_changes($form, $form_state)
{
    $enable_ldap = $form['miniorange_ldap_enable_ldap']['#value'];
    variable_set('miniorange_ldap_enable_ldap',$enable_ldap);

    $auto_reg_users = $form['miniorange_ldap_enable_auto_reg']['#value'];
    variable_set('miniorange_ldap_enable_auto_reg',$auto_reg_users);

    $mo_ldap_server = trim($form['miniorange_ldap_server']['#value']);
    variable_set('miniorange_ldap_server', $mo_ldap_server);

    $enable_tls = $form['miniorange_ldap_enable_tls']['#value'];
    variable_set('miniorange_ldap_enable_tls', $enable_tls);

    $server_account_username = $form['miniorange_ldap_server_account_username']['#value'];
    variable_set('miniorange_ldap_server_account_username', $server_account_username);

    if(!empty($form['miniorange_ldap_server_account_password']['#value'])){
        $server_account_password = $form['miniorange_ldap_server_account_password']['#value'];
        variable_set('miniorange_ldap_server_account_password', $server_account_password);
    }
    $searchBase = $form['miniorange_ldap_search_base']['#value'];
    variable_set('miniorange_ldap_search_base',$searchBase);

    $usernameAttribute = $form['miniorange_ldap_username_attribute']['#value'];
    variable_set('miniorange_ldap_username_attribute',$usernameAttribute);
    user_cookie_save(array("mo_ldap_test" => true));
    $error = test_mo_config();
    if($error[0] == 'error')
        drupal_set_message(t($error[1]),'error');
    else
        drupal_set_message(t($error[1]));
}
global $base_url;
?>
<script>
	function testConfig(){
        var p2Test = "testConfig";
    	var pathparts = location.pathname.split('/');
        if (location.host == 'localhost') {
            var burl = location.origin+'/'+pathparts[1].trim('/')+'/'; // http://localhost/myproject/
        }else{
            var burl = location.origin; // http://demosite.com
        }
	    var testUrl =burl + p2Test;
	    var myWindow = window.open(testUrl, "TEST LDAP Login", "scrollbars=1 width=800, height=600");		
    }
    function ping_server(){
        var ping_server_rem_url = "pingServer";
	    var pathparts = location.pathname.split('/');
        if (location.host == 'localhost') {
            var burl = location.origin+'/'+pathparts[1].trim('/')+'/'; // http://localhost/myproject/
        }else{
            var burl = location.origin; // http://demosite.com
        }
	    var ping_url =burl + ping_server_rem_url;
	    var myWindow = window.open(ping_url, "TEST LDAP Connection", "scrollbars=1 width=800, height=600");
    }
</script>